Subject: Re: [PATCH 0/9] make stash apply with --index by default

From: Junio C Hamano <[email-masked]>
Date: Mon, 12 May 2025 05:52:08 -0700

"D. Ben Knoble" <[email-masked]> writes:

> Since git-stash's inception, it has defaulted to stashing the index but not
> restoring it. This has caused some confusion: change the default as part of Git
> 3.0 to unstash the index, too.

I am very tempted to veto this, as I very much recall trying to see
how I liked it and used in my workflow (by using an alias to do the
"pop" always used with "--index"), got quite frustrated seeing that
a lot of times the command would have worked perfectly well if the
"--index" option weren't given, and gave up after a few weeks even
though I tried very hard to like it as the default.

As "--index" is a Boolean option, I can see that we probably already
have "--no-index" for free, so there is an escape hatch already, but
I do not think it would give a good end-user experience to force
them to keep saying "--no-index" (that is 3 keystrokes longer than
what those who want "--index" need to type).